﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Forms;

using Styx;
using Styx.Common;

namespace DoUntil
{
    public partial class SettingsDialog : Form
    {
        public static SettingsDialog Instance = null;

        public SettingsDialog()
        {
            InitializeComponent();
            Instance = this;
        }

        public static bool IsValid /* Thanks to Geeky's GeekyIrc */
        {
            get { return Instance != null && Instance.Visible && !Instance.Disposing && !Instance.IsDisposed; }
        }

        private void SettingsDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                DoUntil._thisInstance.ItemCount = UInt32.Parse(this.textBox1.Text);
                DoUntil._thisInstance.ItemID = UInt32.Parse(this.textBox2.Text);
            }
            catch (Exception ex)
            {
                DoUntil._thisInstance.Log("I got an Exception. Most likely you did not enter a valid Integer above.");
                Logging.WriteException(ex);
            }

            if (DoUntil._thisInstance.ItemCount == 0)
                DoUntil._thisInstance.Log("Warning: an ItemCount of 0 will instantly stop the Bot!!");
        }


        /// <summary>
        /// We will Load Up Settings into the Plugin, once the Window is re-shown, however if you click outside and click back in, it will overwrite your typings...
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SettingsDialog_Activated(object sender, EventArgs e)
        {
            if (textBox1.Text == "") /* recreated window */
            {
                this.textBox1.Text = DoUntil._thisInstance.ItemCount.ToString();
                this.textBox2.Text = DoUntil._thisInstance.ItemID.ToString();
            }
        }

    }
}
